// amudhtml.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "my_ansi.h"


#define ESCAPE_SEQ  "\x1b"
#define ESCAPE_SEQ1 "\x1bp"
//#define ESCAPE_SEQ "AA"


typedef struct escape_html {
    char escape[128];
	char html[128];
} escape_html;

escape_html e_h[] = {
	{"1;31m",RED_LIGHT},
	{"1;32m",GREEN_LIGHT},
	{"1;33m",YELLOW_LIGHT},
    {"1;34m",BLUE_LIGHT},
    {"1;35m",MAGENTA_LIGHT},
    {"1;36m",CYAN_LIGHT},
    {"1;37m",WHITE_LIGHT},
	{"0;1;31m",RED_LIGHT},
	{"0;1;32m",GREEN_LIGHT},
	{"0;1;33m",YELLOW_LIGHT},
    {"0;1;34m",BLUE_LIGHT},
    {"0;1;35m",MAGENTA_LIGHT},
    {"0;1;36m",CYAN_LIGHT},
    {"0;1;37m",WHITE_LIGHT},
	{"31m",RED},
	{"32m",GREEN},
	{"33m",BROWN},
    {"34m",BLUE},
    {"35m",MAGENTA},
    {"36m",CYAN},
    {"37m",WHITE},
	{"0;31m",RED},
	{"0;32m",GREEN},
	{"0;33m",BROWN},
    {"0;34m",BLUE},
    {"0;35m",MAGENTA},
    {"0;36m",CYAN},
    {"0;37m",WHITE},
	{"0m",DEFAULT_COLOR},
	{"0;0m",DEFAULT_COLOR}
};






char *do_escape(char *escape,FILE *out) {
	static char ret[128];
	static int first=1;
	int i;
	for(i=0;i<sizeof(e_h)/sizeof(escape_html);i++) {
		if((strcmp(escape,e_h[i].escape)) == 0) {
			if(!first) {
			 fputs("</font>",out);
			}
			else {
			 first = 0;
			}
			 fputs("<font color = \"",out);
			 fputs(e_h[i].html,out);
			 fputs("\">",out);
		}
	}
ret[0]=0;
return ret;
}

int usage() {
	printf("Amud ANSI Log -> HTML\n");
	printf("Designed by Sitq, 2000\n");
	printf("Usage:\n");
    printf("amudhtml.exe logfile htmlfile\n");
	return 1;
}



int main(int argc, char* argv[])
{

// This is a simply converer, here is no need to pass parameters to programm

// atempts to read stdin

char buf[1024]; // I think no more need
char escape[128];
char *pos;
char *end_escape;
char *beg_escape;
char *beg;
FILE *in;
FILE *out;


if(argc < 2) {
	usage();
	return 1;
}

   if( (in  = fopen( argv[1], "r" )) == NULL ) {
     printf( "The file %s was not opened\n" , argv[1]);   
	 usage();
	 return 1;
   }

   if( (out = fopen( argv[2], "w" )) == NULL ) {
     printf( "The file %s was not opened\n" , argv[2]);
  	 usage();
	 return 1;
   }

    
    fputs("<body bgcolor=\"Black\" text=\"#808080\"><pre>",out);
    fputs("<font face = \"fixedsys\">",out);
    fputs("<font color = \"FFFFFF\">**** , ,       ****</font>\n\n",out);
    fputs("<font color = \"FFFFFF\">****      ****</font>\n\n",out);
	while(!feof(in)) {
	  if((fgets(buf,sizeof(buf)-1,in)) == NULL) break;
	  buf[sizeof(buf)-1] = 0;
	  beg=buf;
	  pos=strstr(buf,ESCAPE_SEQ);
	  while(pos != NULL) {
       beg_escape = pos+2;
	   end_escape = pos+2;
	   while(isdigit(*end_escape) || *end_escape == ';' || *end_escape == ':') end_escape++;
	   if((end_escape-beg_escape+1)<128) {
	    strncpy(escape,beg_escape,(end_escape-beg_escape+1));
		escape[end_escape-beg_escape+1] = 0;
	   }
	   else {
		strncpy(escape,beg_escape,127);
		escape[127]=0;
	   }
	   *pos = 0;
       fputs(beg,out);
	   beg = end_escape+1;
	   pos = strstr(beg,ESCAPE_SEQ);
	   fputs(do_escape(escape,out),out);
	  }
	  fputs(beg,out);
	  fputs("<br>",out);
	}
             fputs("\n\n<font color = \"FFFFFF\">**** , ,   **** <font>\n\n",out);
			 fputs("</pre>",out);
			 fputs("</font>",out);
             fputs("</body>",out);


return 0;
}

